package sample;

import javax.annotation.Resource;
import javax.annotation.Resources;
import javax.annotation.security.RolesAllowed;
import javax.ejb.LocalBean;
import javax.ejb.SessionContext;
import javax.ejb.Stateful;
import javax.ejb.Stateless;
import org.jboss.ejb3.annotation.Clustered;
import org.jboss.ejb3.annotation.SecurityDomain;

/**
 * Session Bean implementation class HelloBean
 */
//@Stateless
@Stateful
@LocalBean
@SecurityDomain("ejbDomain")
//@Resources( {
//    @Resource(name="java:/jboss/exported/foo/SecureHelloBean", mappedName="java:module/SecureHelloBean!sample.Hello")
//})
@Clustered
public class SecureHelloBean implements Hello {

    @Resource
    private SessionContext sessionContext;
    
    /**
     * Default constructor. 
     */
    public SecureHelloBean() {
        // TODO Auto-generated constructor stub
    }
    
    @Override
    @RolesAllowed({"user"})
    public String hello()
    {
    	System.out.println("[SecureHelloBean] hello() invoked by " + sessionContext.getCallerPrincipal());

    	String hello = "Secure Hello, " + sessionContext.getCallerPrincipal();

    	return hello;
    }
}
